/*Class for communicating with the sz program*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>


#define MOSERIAL_TYPE_SZWRAPPER (moserial_szwrapper_get_type ())
#define MOSERIAL_SZWRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MOSERIAL_TYPE_SZWRAPPER, moserialSzwrapper))
#define MOSERIAL_SZWRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MOSERIAL_TYPE_SZWRAPPER, moserialSzwrapperClass))
#define MOSERIAL_IS_SZWRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MOSERIAL_TYPE_SZWRAPPER))
#define MOSERIAL_IS_SZWRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MOSERIAL_TYPE_SZWRAPPER))
#define MOSERIAL_SZWRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MOSERIAL_TYPE_SZWRAPPER, moserialSzwrapperClass))

typedef struct _moserialSzwrapper moserialSzwrapper;
typedef struct _moserialSzwrapperClass moserialSzwrapperClass;
typedef struct _moserialSzwrapperPrivate moserialSzwrapperPrivate;

#define MOSERIAL_SZWRAPPER_TYPE_PROTOCOL (moserial_szwrapper_protocol_get_type ())

#define MOSERIAL_TYPE_SERIAL_CONNECTION (moserial_serial_connection_get_type ())
#define MOSERIAL_SERIAL_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MOSERIAL_TYPE_SERIAL_CONNECTION, moserialSerialConnection))
#define MOSERIAL_SERIAL_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MOSERIAL_TYPE_SERIAL_CONNECTION, moserialSerialConnectionClass))
#define MOSERIAL_IS_SERIAL_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MOSERIAL_TYPE_SERIAL_CONNECTION))
#define MOSERIAL_IS_SERIAL_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MOSERIAL_TYPE_SERIAL_CONNECTION))
#define MOSERIAL_SERIAL_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MOSERIAL_TYPE_SERIAL_CONNECTION, moserialSerialConnectionClass))

typedef struct _moserialSerialConnection moserialSerialConnection;
typedef struct _moserialSerialConnectionClass moserialSerialConnectionClass;

struct _moserialSzwrapper {
	GObject parent_instance;
	moserialSzwrapperPrivate * priv;
	gboolean running;
};

struct _moserialSzwrapperClass {
	GObjectClass parent_class;
};

typedef enum  {
	MOSERIAL_SZWRAPPER_PROTOCOL_XMODEM,
	MOSERIAL_SZWRAPPER_PROTOCOL_YMODEM,
	MOSERIAL_SZWRAPPER_PROTOCOL_ZMODEM,
	MOSERIAL_SZWRAPPER_PROTOCOL_RAW,
	MOSERIAL_SZWRAPPER_PROTOCOL_NULL
} moserialSzwrapperProtocol;

struct _moserialSzwrapperPrivate {
	moserialSzwrapperProtocol _protocol;
	moserialSerialConnection* _sc;
	GIOChannel* IOChannelInput;
	GIOChannel* IOChannelOutput;
	GIOChannel* IOChannelError;
	guint outputChannelId;
	guint errorChannelId;
	GPid pid;
	char* _filename;
};


static gpointer moserial_szwrapper_parent_class = NULL;

GType moserial_szwrapper_get_type (void);
GType moserial_szwrapper_protocol_get_type (void);
GType moserial_serial_connection_get_type (void);
#define MOSERIAL_SZWRAPPER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), MOSERIAL_TYPE_SZWRAPPER, moserialSzwrapperPrivate))
enum  {
	MOSERIAL_SZWRAPPER_DUMMY_PROPERTY,
	MOSERIAL_SZWRAPPER_PROTOCOL,
	MOSERIAL_SZWRAPPER_SC,
	MOSERIAL_SZWRAPPER_FILENAME
};
static void moserial_szwrapper_set_protocol (moserialSzwrapper* self, moserialSzwrapperProtocol value);
static void moserial_szwrapper_set_sc (moserialSzwrapper* self, moserialSerialConnection* value);
static void moserial_szwrapper_set_filename (moserialSzwrapper* self, const char* value);
moserialSzwrapper* moserial_szwrapper_new (moserialSzwrapperProtocol* protocol, moserialSerialConnection* sc, const char* filename);
moserialSzwrapper* moserial_szwrapper_construct (GType object_type, moserialSzwrapperProtocol* protocol, moserialSerialConnection* sc, const char* filename);
static void moserial_szwrapper_shutdown (moserialSzwrapper* self);
void moserial_szwrapper_writeChar (moserialSzwrapper* self, guchar byte);
char* mo_utils_getLastMessage (const char* messages);
static gboolean moserial_szwrapper_shutdown_timeout (moserialSzwrapper* self);
static gboolean _moserial_szwrapper_shutdown_timeout_gsource_func (gpointer self);
static gboolean moserial_szwrapper_readError (moserialSzwrapper* self, GIOChannel* source, GIOCondition condition);
moserialSzwrapperProtocol moserial_szwrapper_get_protocol (moserialSzwrapper* self);
moserialSerialConnection* moserial_szwrapper_get_sc (moserialSzwrapper* self);
void moserial_serial_connection_sendByte (moserialSerialConnection* self, guchar byte);
void moserial_szwrapper_transferCanceled (moserialSzwrapper* self, GObject* o);
void moserial_serial_connection_sendBytes (moserialSerialConnection* self, gchar* bytes, int bytes_length1, gsize size);
static gboolean moserial_szwrapper_readBytes (moserialSzwrapper* self, GIOChannel* source, GIOCondition condition);
const char* moserial_szwrapper_get_filename (moserialSzwrapper* self);
static gboolean _moserial_szwrapper_readBytes_gio_func (GIOChannel* source, GIOCondition condition, gpointer self);
static gboolean _moserial_szwrapper_readError_gio_func (GIOChannel* source, GIOCondition condition, gpointer self);
static GObject * moserial_szwrapper_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void moserial_szwrapper_finalize (GObject* obj);
static void moserial_szwrapper_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void moserial_szwrapper_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static int _vala_strcmp0 (const char * str1, const char * str2);




GType moserial_szwrapper_protocol_get_type (void) {
	static GType moserial_szwrapper_protocol_type_id = 0;
	if (G_UNLIKELY (moserial_szwrapper_protocol_type_id == 0)) {
		static const GEnumValue values[] = {{MOSERIAL_SZWRAPPER_PROTOCOL_XMODEM, "MOSERIAL_SZWRAPPER_PROTOCOL_XMODEM", "xmodem"}, {MOSERIAL_SZWRAPPER_PROTOCOL_YMODEM, "MOSERIAL_SZWRAPPER_PROTOCOL_YMODEM", "ymodem"}, {MOSERIAL_SZWRAPPER_PROTOCOL_ZMODEM, "MOSERIAL_SZWRAPPER_PROTOCOL_ZMODEM", "zmodem"}, {MOSERIAL_SZWRAPPER_PROTOCOL_RAW, "MOSERIAL_SZWRAPPER_PROTOCOL_RAW", "raw"}, {MOSERIAL_SZWRAPPER_PROTOCOL_NULL, "MOSERIAL_SZWRAPPER_PROTOCOL_NULL", "null"}, {0, NULL, NULL}};
		moserial_szwrapper_protocol_type_id = g_enum_register_static ("moserialSzwrapperProtocol", values);
	}
	return moserial_szwrapper_protocol_type_id;
}


moserialSzwrapper* moserial_szwrapper_construct (GType object_type, moserialSzwrapperProtocol* protocol, moserialSerialConnection* sc, const char* filename) {
	GParameter * __params;
	GParameter * __params_it;
	moserialSzwrapper * self;
	__params = g_new0 (GParameter, 3);
	__params_it = __params;
	__params_it->name = "protocol";
	g_value_init (&__params_it->value, MOSERIAL_SZWRAPPER_TYPE_PROTOCOL);
	g_value_set_enum (&__params_it->value, *protocol);
	__params_it++;
	__params_it->name = "sc";
	g_value_init (&__params_it->value, MOSERIAL_TYPE_SERIAL_CONNECTION);
	g_value_set_object (&__params_it->value, sc);
	__params_it++;
	__params_it->name = "filename";
	g_value_init (&__params_it->value, G_TYPE_STRING);
	g_value_set_string (&__params_it->value, filename);
	__params_it++;
	self = g_object_newv (object_type, __params_it - __params, __params);
	while (__params_it > __params) {
		--__params_it;
		g_value_unset (&__params_it->value);
	}
	g_free (__params);
	return self;
}


moserialSzwrapper* moserial_szwrapper_new (moserialSzwrapperProtocol* protocol, moserialSerialConnection* sc, const char* filename) {
	return moserial_szwrapper_construct (MOSERIAL_TYPE_SZWRAPPER, protocol, sc, filename);
}


void moserial_szwrapper_writeChar (moserialSzwrapper* self, guchar byte) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	if (self->running) {
		gsize bytesWritten;
		gchar* _tmp0_;
		gint b_size;
		gint b_length1;
		gchar* b;
		bytesWritten = 0UL;
		_tmp0_ = NULL;
		b = (_tmp0_ = g_new0 (gchar, 1), b_length1 = 1, b_size = b_length1, _tmp0_);
		b[0] = (gchar) byte;
		{
			if (self->running) {
				g_io_channel_write_chars (self->priv->IOChannelInput, b, b_length1, &bytesWritten, &_inner_error_);
				if (_inner_error_ != NULL) {
					if (_inner_error_->domain == G_IO_CHANNEL_ERROR) {
						goto __catch17_g_io_channel_error;
					}
					if (_inner_error_->domain == G_CONVERT_ERROR) {
						goto __catch17_g_convert_error;
					}
					goto __finally17;
				}
			}
			if (self->running) {
				g_io_channel_flush (self->priv->IOChannelInput, &_inner_error_);
				if (_inner_error_ != NULL) {
					if (_inner_error_->domain == G_IO_CHANNEL_ERROR) {
						goto __catch17_g_io_channel_error;
					}
					if (_inner_error_->domain == G_CONVERT_ERROR) {
						goto __catch17_g_convert_error;
					}
					goto __finally17;
				}
			}
		}
		goto __finally17;
		__catch17_g_io_channel_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
				moserial_szwrapper_shutdown (self);
				fprintf (stdout, "writeChar() %s\n", e->message);
				(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
			}
		}
		goto __finally17;
		__catch17_g_convert_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
				fprintf (stdout, "%s\n", e->message);
				(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
			}
		}
		__finally17:
		if (_inner_error_ != NULL) {
			b = (g_free (b), NULL);
			g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
			g_clear_error (&_inner_error_);
			return;
		}
		b = (g_free (b), NULL);
	}
}


static gboolean _moserial_szwrapper_shutdown_timeout_gsource_func (gpointer self) {
	return moserial_szwrapper_shutdown_timeout (self);
}


static gboolean moserial_szwrapper_readError (moserialSzwrapper* self, GIOChannel* source, GIOCondition condition) {
	gboolean result;
	GError * _inner_error_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (source != NULL, FALSE);
	_inner_error_ = NULL;
	while (TRUE) {
		gboolean _tmp0_;
		_tmp0_ = FALSE;
		if (gtk_events_pending ()) {
			_tmp0_ = TRUE;
		} else {
			_tmp0_ = gdk_events_pending ();
		}
		if (!_tmp0_) {
			break;
		}
		gtk_main_iteration_do (TRUE);
	}
	if (self->running) {
		gchar* _tmp1_;
		gint m_buf_size;
		gint m_buf_length1;
		gchar* m_buf;
		char* messages;
		char* message;
		gsize bytesRead;
		char* _tmp6_;
		_tmp1_ = NULL;
		m_buf = (_tmp1_ = g_new0 (gchar, 1000), m_buf_length1 = 1000, m_buf_size = m_buf_length1, _tmp1_);
		messages = g_strdup ("");
		message = g_strdup ("");
		bytesRead = (gsize) 0;
		if (!(condition == G_IO_IN)) {
			result = TRUE;
			m_buf = (g_free (m_buf), NULL);
			messages = (g_free (messages), NULL);
			message = (g_free (message), NULL);
			return result;
		}
		{
			g_io_channel_read_chars (source, m_buf, m_buf_length1, &bytesRead, &_inner_error_);
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == G_CONVERT_ERROR) {
					goto __catch18_g_convert_error;
				}
				goto __finally18;
			}
		}
		goto __finally18;
		__catch18_g_convert_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
				fprintf (stdout, "%s\n", e->message);
				(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
			}
		}
		__finally18:
		if (_inner_error_ != NULL) {
			m_buf = (g_free (m_buf), NULL);
			messages = (g_free (messages), NULL);
			message = (g_free (message), NULL);
			g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		{
			gint x;
			x = 0;
			{
				gboolean _tmp2_;
				_tmp2_ = TRUE;
				while (TRUE) {
					gunichar c;
					gboolean _tmp3_;
					if (!_tmp2_) {
						x++;
					}
					_tmp2_ = FALSE;
					if (!(x < bytesRead)) {
						break;
					}
					c = (gunichar) m_buf[x];
					_tmp3_ = FALSE;
					if (g_unichar_isprint (c)) {
						_tmp3_ = TRUE;
					} else {
						_tmp3_ = g_unichar_isspace (c);
					}
					if (_tmp3_) {
						char* _tmp5_;
						char* _tmp4_;
						_tmp5_ = NULL;
						_tmp4_ = NULL;
						messages = (_tmp5_ = g_strconcat (messages, _tmp4_ = g_strdup_printf ("%c", (gint) m_buf[x]), NULL), messages = (g_free (messages), NULL), _tmp5_);
						_tmp4_ = (g_free (_tmp4_), NULL);
					}
				}
			}
		}
		_tmp6_ = NULL;
		message = (_tmp6_ = mo_utils_getLastMessage (messages), message = (g_free (message), NULL), _tmp6_);
		if (!(_vala_strcmp0 (message, "") == 0)) {
			g_signal_emit_by_name (self, "update-status", message);
		}
		if (!(strstr (messages, "Transfer complete") == NULL)) {
			g_timeout_add ((guint) 2000, _moserial_szwrapper_shutdown_timeout_gsource_func, self);
		}
		/*Wait 2 seconds for for the final remote packet to get ackd
		shutdown();*/
		if (!(strstr (messages, "Transfer incomplete") == NULL)) {
			moserial_szwrapper_shutdown (self);
		}
		result = TRUE;
		m_buf = (g_free (m_buf), NULL);
		messages = (g_free (messages), NULL);
		message = (g_free (message), NULL);
		return result;
	} else {
		result = FALSE;
		return result;
	}
}


void moserial_szwrapper_transferCanceled (moserialSzwrapper* self, GObject* o) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (o != NULL);
	/*send cancel string to remote client and rz*/
	if (self->running) {
		gboolean _tmp0_;
		gboolean _tmp1_;
		gboolean _tmp3_;
		gboolean _tmp4_;
		g_signal_emit_by_name (self, "update-status", _ ("canceled"));
		_tmp0_ = FALSE;
		_tmp1_ = FALSE;
		if (self->priv->_protocol == MOSERIAL_SZWRAPPER_PROTOCOL_XMODEM) {
			_tmp1_ = TRUE;
		} else {
			_tmp1_ = self->priv->_protocol == MOSERIAL_SZWRAPPER_PROTOCOL_YMODEM;
		}
		if (_tmp1_) {
			_tmp0_ = TRUE;
		} else {
			_tmp0_ = self->priv->_protocol == MOSERIAL_SZWRAPPER_PROTOCOL_ZMODEM;
		}
		if (_tmp0_) {
			{
				gint x;
				x = 0;
				{
					gboolean _tmp2_;
					_tmp2_ = TRUE;
					while (TRUE) {
						if (!_tmp2_) {
							x++;
						}
						_tmp2_ = FALSE;
						if (!(x < 20)) {
							break;
						}
						if (self->priv->_protocol == MOSERIAL_SZWRAPPER_PROTOCOL_ZMODEM) {
							moserial_serial_connection_sendByte (self->priv->_sc, (guchar) ('X' & 037));
							moserial_szwrapper_writeChar (self, (guchar) ('X' & 037));
						} else {
							moserial_serial_connection_sendByte (self->priv->_sc, (guchar) 0x18);
						}
					}
				}
			}
		}
		_tmp3_ = FALSE;
		_tmp4_ = FALSE;
		if (self->priv->_protocol == MOSERIAL_SZWRAPPER_PROTOCOL_XMODEM) {
			_tmp4_ = TRUE;
		} else {
			_tmp4_ = self->priv->_protocol == MOSERIAL_SZWRAPPER_PROTOCOL_YMODEM;
		}
		if (_tmp4_) {
			_tmp3_ = TRUE;
		} else {
			_tmp3_ = self->priv->_protocol == MOSERIAL_SZWRAPPER_PROTOCOL_RAW;
		}
		if (_tmp3_) {
			moserial_szwrapper_shutdown (self);
		}
	}
}


static gboolean moserial_szwrapper_shutdown_timeout (moserialSzwrapper* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	moserial_szwrapper_shutdown (self);
	result = FALSE;
	return result;
}


static void moserial_szwrapper_shutdown (moserialSzwrapper* self) {
	g_return_if_fail (self != NULL);
	if (self->running) {
		self->running = FALSE;
		g_source_remove (self->priv->outputChannelId);
		g_source_remove (self->priv->errorChannelId);
		g_spawn_close_pid (self->priv->pid);
		g_signal_emit_by_name (self, "transfer-complete");
	}
}


static gboolean moserial_szwrapper_readBytes (moserialSzwrapper* self, GIOChannel* source, GIOCondition condition) {
	gboolean result;
	GError * _inner_error_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (source != NULL, FALSE);
	_inner_error_ = NULL;
	while (TRUE) {
		gboolean _tmp0_;
		_tmp0_ = FALSE;
		if (gtk_events_pending ()) {
			_tmp0_ = TRUE;
		} else {
			_tmp0_ = gdk_events_pending ();
		}
		if (!_tmp0_) {
			break;
		}
		gtk_main_iteration_do (TRUE);
	}
	if (self->running) {
		gchar* _tmp1_;
		gint m_buf_size;
		gint m_buf_length1;
		gchar* m_buf;
		gsize bytesRead;
		_tmp1_ = NULL;
		m_buf = (_tmp1_ = g_new0 (gchar, 1024), m_buf_length1 = 1024, m_buf_size = m_buf_length1, _tmp1_);
		bytesRead = (gsize) 0;
		if (!(condition == G_IO_IN)) {
			result = TRUE;
			m_buf = (g_free (m_buf), NULL);
			return result;
		}
		{
			g_io_channel_read_chars (source, m_buf, m_buf_length1, &bytesRead, &_inner_error_);
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == G_CONVERT_ERROR) {
					goto __catch19_g_convert_error;
				}
				goto __finally19;
			}
		}
		goto __finally19;
		__catch19_g_convert_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
				fprintf (stdout, "%s\n", e->message);
				(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
			}
		}
		__finally19:
		if (_inner_error_ != NULL) {
			m_buf = (g_free (m_buf), NULL);
			g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		moserial_serial_connection_sendBytes (self->priv->_sc, m_buf, m_buf_length1, bytesRead);
		result = TRUE;
		m_buf = (g_free (m_buf), NULL);
		return result;
	} else {
		result = FALSE;
		return result;
	}
}


moserialSzwrapperProtocol moserial_szwrapper_get_protocol (moserialSzwrapper* self) {
	moserialSzwrapperProtocol result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_protocol;
	return result;
}


static void moserial_szwrapper_set_protocol (moserialSzwrapper* self, moserialSzwrapperProtocol value) {
	g_return_if_fail (self != NULL);
	self->priv->_protocol = value;
	g_object_notify ((GObject *) self, "protocol");
}


moserialSerialConnection* moserial_szwrapper_get_sc (moserialSzwrapper* self) {
	moserialSerialConnection* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_sc;
	return result;
}


static void moserial_szwrapper_set_sc (moserialSzwrapper* self, moserialSerialConnection* value) {
	moserialSerialConnection* _tmp1_;
	moserialSerialConnection* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp1_ = NULL;
	_tmp0_ = NULL;
	self->priv->_sc = (_tmp1_ = (_tmp0_ = value, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->priv->_sc == NULL) ? NULL : (self->priv->_sc = (g_object_unref (self->priv->_sc), NULL)), _tmp1_);
	g_object_notify ((GObject *) self, "sc");
}


const char* moserial_szwrapper_get_filename (moserialSzwrapper* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_filename;
	return result;
}


static void moserial_szwrapper_set_filename (moserialSzwrapper* self, const char* value) {
	char* _tmp1_;
	const char* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp1_ = NULL;
	_tmp0_ = NULL;
	self->priv->_filename = (_tmp1_ = (_tmp0_ = value, (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_)), self->priv->_filename = (g_free (self->priv->_filename), NULL), _tmp1_);
	g_object_notify ((GObject *) self, "filename");
}


static gboolean _moserial_szwrapper_readBytes_gio_func (GIOChannel* source, GIOCondition condition, gpointer self) {
	return moserial_szwrapper_readBytes (self, source, condition);
}


static gboolean _moserial_szwrapper_readError_gio_func (GIOChannel* source, GIOCondition condition, gpointer self) {
	return moserial_szwrapper_readError (self, source, condition);
}


static GObject * moserial_szwrapper_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	moserialSzwrapperClass * klass;
	GObjectClass * parent_class;
	moserialSzwrapper * self;
	GError * _inner_error_;
	klass = MOSERIAL_SZWRAPPER_CLASS (g_type_class_peek (MOSERIAL_TYPE_SZWRAPPER));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = MOSERIAL_SZWRAPPER (obj);
	_inner_error_ = NULL;
	{
		gboolean _tmp0_;
		_tmp0_ = FALSE;
		if (self->priv->_protocol == MOSERIAL_SZWRAPPER_PROTOCOL_NULL) {
			_tmp0_ = TRUE;
		} else {
			_tmp0_ = self->priv->_filename == NULL;
		}
		if (_tmp0_) {
			self->running = FALSE;
		} else {
			gint argv_size;
			gint argv_length1;
			char** argv;
			gint output;
			gint _error_;
			gint input;
			argv = (argv_length1 = 0, NULL);
			if (self->priv->_protocol == MOSERIAL_SZWRAPPER_PROTOCOL_RAW) {
				char** _tmp1_;
				char* _tmp2_;
				char* _tmp4_;
				const char* _tmp3_;
				_tmp1_ = NULL;
				argv = (_tmp1_ = g_new0 (char*, 2 + 1), argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL), argv_length1 = 2, argv_size = argv_length1, _tmp1_);
				_tmp2_ = NULL;
				argv[0] = (_tmp2_ = g_strdup ("cat"), argv[0] = (g_free (argv[0]), NULL), _tmp2_);
				_tmp4_ = NULL;
				_tmp3_ = NULL;
				argv[1] = (_tmp4_ = (_tmp3_ = self->priv->_filename, (_tmp3_ == NULL) ? NULL : g_strdup (_tmp3_)), argv[1] = (g_free (argv[1]), NULL), _tmp4_);
			} else {
				char** _tmp5_;
				char* _tmp6_;
				char* _tmp10_;
				char* _tmp12_;
				const char* _tmp11_;
				_tmp5_ = NULL;
				argv = (_tmp5_ = g_new0 (char*, 4 + 1), argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL), argv_length1 = 4, argv_size = argv_length1, _tmp5_);
				_tmp6_ = NULL;
				argv[0] = (_tmp6_ = g_strdup ("sz"), argv[0] = (g_free (argv[0]), NULL), _tmp6_);
				switch (self->priv->_protocol) {
					case MOSERIAL_SZWRAPPER_PROTOCOL_XMODEM:
					{
						char* _tmp7_;
						_tmp7_ = NULL;
						argv[1] = (_tmp7_ = g_strdup ("--xmodem"), argv[1] = (g_free (argv[1]), NULL), _tmp7_);
						break;
					}
					case MOSERIAL_SZWRAPPER_PROTOCOL_YMODEM:
					{
						char* _tmp8_;
						_tmp8_ = NULL;
						argv[1] = (_tmp8_ = g_strdup ("--ymodem"), argv[1] = (g_free (argv[1]), NULL), _tmp8_);
						break;
					}
					default:
					{
						char* _tmp9_;
						_tmp9_ = NULL;
						argv[1] = (_tmp9_ = g_strdup ("--zmodem"), argv[1] = (g_free (argv[1]), NULL), _tmp9_);
						break;
					}
				}
				_tmp10_ = NULL;
				argv[2] = (_tmp10_ = g_strdup ("-vv"), argv[2] = (g_free (argv[2]), NULL), _tmp10_);
				_tmp12_ = NULL;
				_tmp11_ = NULL;
				argv[3] = (_tmp12_ = (_tmp11_ = self->priv->_filename, (_tmp11_ == NULL) ? NULL : g_strdup (_tmp11_)), argv[3] = (g_free (argv[3]), NULL), _tmp12_);
			}
			output = 0;
			_error_ = 0;
			input = 0;
			{
				GIOChannel* _tmp13_;
				GIOChannel* _tmp14_;
				GIOChannel* _tmp15_;
				g_spawn_async_with_pipes (NULL, argv, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &self->priv->pid, &input, &output, &_error_, &_inner_error_);
				if (_inner_error_ != NULL) {
					if (_inner_error_->domain == G_SPAWN_ERROR) {
						goto __catch20_g_spawn_error;
					}
					goto __finally20;
				}
				_tmp13_ = NULL;
				self->priv->IOChannelOutput = (_tmp13_ = g_io_channel_unix_new (output), (self->priv->IOChannelOutput == NULL) ? NULL : (self->priv->IOChannelOutput = (g_io_channel_unref (self->priv->IOChannelOutput), NULL)), _tmp13_);
				_tmp14_ = NULL;
				self->priv->IOChannelInput = (_tmp14_ = g_io_channel_unix_new (input), (self->priv->IOChannelInput == NULL) ? NULL : (self->priv->IOChannelInput = (g_io_channel_unref (self->priv->IOChannelInput), NULL)), _tmp14_);
				_tmp15_ = NULL;
				self->priv->IOChannelError = (_tmp15_ = g_io_channel_unix_new (_error_), (self->priv->IOChannelError == NULL) ? NULL : (self->priv->IOChannelError = (g_io_channel_unref (self->priv->IOChannelError), NULL)), _tmp15_);
				g_io_channel_set_encoding (self->priv->IOChannelOutput, NULL, &_inner_error_);
				if (_inner_error_ != NULL) {
					if (_inner_error_->domain == G_SPAWN_ERROR) {
						goto __catch20_g_spawn_error;
					}
					goto __finally20;
				}
				g_io_channel_set_flags (self->priv->IOChannelOutput, G_IO_FLAG_NONBLOCK, &_inner_error_);
				if (_inner_error_ != NULL) {
					if (_inner_error_->domain == G_SPAWN_ERROR) {
						goto __catch20_g_spawn_error;
					}
					goto __finally20;
				}
				g_io_channel_set_encoding (self->priv->IOChannelError, NULL, &_inner_error_);
				if (_inner_error_ != NULL) {
					if (_inner_error_->domain == G_SPAWN_ERROR) {
						goto __catch20_g_spawn_error;
					}
					goto __finally20;
				}
				g_io_channel_set_flags (self->priv->IOChannelError, G_IO_FLAG_NONBLOCK, &_inner_error_);
				if (_inner_error_ != NULL) {
					if (_inner_error_->domain == G_SPAWN_ERROR) {
						goto __catch20_g_spawn_error;
					}
					goto __finally20;
				}
				g_io_channel_set_encoding (self->priv->IOChannelInput, NULL, &_inner_error_);
				if (_inner_error_ != NULL) {
					if (_inner_error_->domain == G_SPAWN_ERROR) {
						goto __catch20_g_spawn_error;
					}
					goto __finally20;
				}
				/*IOChannelInput.set_flags(GLib.IOFlags.NONBLOCK);*/
				self->priv->outputChannelId = g_io_add_watch (self->priv->IOChannelOutput, G_IO_IN, _moserial_szwrapper_readBytes_gio_func, self);
				self->priv->errorChannelId = g_io_add_watch (self->priv->IOChannelError, G_IO_IN, _moserial_szwrapper_readError_gio_func, self);
				self->running = TRUE;
			}
			goto __finally20;
			__catch20_g_spawn_error:
			{
				GError * e;
				e = _inner_error_;
				_inner_error_ = NULL;
				{
					char* _tmp16_;
					GtkMessageDialog* _tmp17_;
					GtkMessageDialog* errorDialog;
					self->running = FALSE;
					fprintf (stdout, "spawn error: %s\n", e->message);
					_tmp16_ = NULL;
					_tmp17_ = NULL;
					errorDialog = (_tmp17_ = g_object_ref_sink ((GtkMessageDialog*) gtk_message_dialog_new (NULL, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, _tmp16_ = g_strdup_printf ("%s", e->message), NULL)), _tmp16_ = (g_free (_tmp16_), NULL), _tmp17_);
					gtk_dialog_run ((GtkDialog*) errorDialog);
					gtk_object_destroy ((GtkObject*) errorDialog);
					(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
					(errorDialog == NULL) ? NULL : (errorDialog = (g_object_unref (errorDialog), NULL));
				}
			}
			__finally20:
			if (_inner_error_ != NULL) {
				argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
				g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
				g_clear_error (&_inner_error_);
			}
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
		}
	}
	return obj;
}


static void moserial_szwrapper_class_init (moserialSzwrapperClass * klass) {
	moserial_szwrapper_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (moserialSzwrapperPrivate));
	G_OBJECT_CLASS (klass)->get_property = moserial_szwrapper_get_property;
	G_OBJECT_CLASS (klass)->set_property = moserial_szwrapper_set_property;
	G_OBJECT_CLASS (klass)->constructor = moserial_szwrapper_constructor;
	G_OBJECT_CLASS (klass)->finalize = moserial_szwrapper_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MOSERIAL_SZWRAPPER_PROTOCOL, g_param_spec_enum ("protocol", "protocol", "protocol", MOSERIAL_SZWRAPPER_TYPE_PROTOCOL, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MOSERIAL_SZWRAPPER_SC, g_param_spec_object ("sc", "sc", "sc", MOSERIAL_TYPE_SERIAL_CONNECTION, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MOSERIAL_SZWRAPPER_FILENAME, g_param_spec_string ("filename", "filename", "filename", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_signal_new ("transfer_complete", MOSERIAL_TYPE_SZWRAPPER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("update_status", MOSERIAL_TYPE_SZWRAPPER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
}


static void moserial_szwrapper_instance_init (moserialSzwrapper * self) {
	self->priv = MOSERIAL_SZWRAPPER_GET_PRIVATE (self);
	self->running = FALSE;
}


static void moserial_szwrapper_finalize (GObject* obj) {
	moserialSzwrapper * self;
	self = MOSERIAL_SZWRAPPER (obj);
	(self->priv->_sc == NULL) ? NULL : (self->priv->_sc = (g_object_unref (self->priv->_sc), NULL));
	(self->priv->IOChannelInput == NULL) ? NULL : (self->priv->IOChannelInput = (g_io_channel_unref (self->priv->IOChannelInput), NULL));
	(self->priv->IOChannelOutput == NULL) ? NULL : (self->priv->IOChannelOutput = (g_io_channel_unref (self->priv->IOChannelOutput), NULL));
	(self->priv->IOChannelError == NULL) ? NULL : (self->priv->IOChannelError = (g_io_channel_unref (self->priv->IOChannelError), NULL));
	self->priv->_filename = (g_free (self->priv->_filename), NULL);
	G_OBJECT_CLASS (moserial_szwrapper_parent_class)->finalize (obj);
}


GType moserial_szwrapper_get_type (void) {
	static GType moserial_szwrapper_type_id = 0;
	if (moserial_szwrapper_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (moserialSzwrapperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) moserial_szwrapper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (moserialSzwrapper), 0, (GInstanceInitFunc) moserial_szwrapper_instance_init, NULL };
		moserial_szwrapper_type_id = g_type_register_static (G_TYPE_OBJECT, "moserialSzwrapper", &g_define_type_info, 0);
	}
	return moserial_szwrapper_type_id;
}


static void moserial_szwrapper_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	moserialSzwrapper * self;
	gpointer boxed;
	self = MOSERIAL_SZWRAPPER (object);
	switch (property_id) {
		case MOSERIAL_SZWRAPPER_PROTOCOL:
		g_value_set_enum (value, moserial_szwrapper_get_protocol (self));
		break;
		case MOSERIAL_SZWRAPPER_SC:
		g_value_set_object (value, moserial_szwrapper_get_sc (self));
		break;
		case MOSERIAL_SZWRAPPER_FILENAME:
		g_value_set_string (value, moserial_szwrapper_get_filename (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void moserial_szwrapper_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	moserialSzwrapper * self;
	self = MOSERIAL_SZWRAPPER (object);
	switch (property_id) {
		case MOSERIAL_SZWRAPPER_PROTOCOL:
		moserial_szwrapper_set_protocol (self, g_value_get_enum (value));
		break;
		case MOSERIAL_SZWRAPPER_SC:
		moserial_szwrapper_set_sc (self, g_value_get_object (value));
		break;
		case MOSERIAL_SZWRAPPER_FILENAME:
		moserial_szwrapper_set_filename (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




